/*************************************************************************************************/
/*                            Fragment Shader for Particle Rendering                             */	
/*************************************************************************************************/

///////////////////////////////////////////////////////////////////////////////////////////////////
// Varying Variables for Fragment Shader

varying float Render;						// Rendering flag

varying vec4 Color;							// Base point color

varying vec3 Screen;						// Screen coords of point center

varying float PointSize;					// Point size in screen space

///////////////////////////////////////////////////////////////////////////////////////////////////
// Shader Entry Point

void main ( void )
{
	if ( Render < 0.0 ) discard;

	float radius = 0.75 * PointSize;

	gl_FragColor = Color * ( radius - distance ( gl_FragCoord.xy, Screen.xy ) ) / radius;
}